#!/usr/bin/python
from folding import *



import sys
import getopt
import random
import string

def reverseComplement(s):
    r=s[::-1]
    c=""
    for l in r:
        l=string.lower(l)
        if l == 'a':
            c+='u'
        elif l == 'c':
            c+='g'
        elif l == 'g':
            c+='c'
        else:
            c+='a'
    return c

def randomRange(b,e,r):
    print b,e,r
    return random.sample(xrange(b,e),r)
    #if r>((e-b)/2):
#	p=range(b,e)
#	while len(p)>r:
 #       	del p[random.randint(0,len(p)-1)]
  #  else:
  #      p={}
  #      while len(p)<r:
  #          i=random.randint(b,e)
  #          p[i]=True
  #      p=p.keys()
  #  return p                 

def parsePositions(positionsStr):
    positions=[]
    for  position in positionsStr.split(','):
        position=position.strip()
        reverse=False
        length=SUBSEQUENCE_LENGTH
        if position[0]=='R':
            reverse=True
            position=position[1:]
        p=position.find("/")
        if p!=-1:
            try:
                length=int(position[p+1:])
            except ValueError, e:
                print >>sys.stderr,"*error* ",e
                print >>sys.stderr,"*error* integer expected after the / ",position
                sys.exit(1)
            position=position[:p]                
        if position[0] in "{[":
            if position[0]=='{':
                if position[-1]!='}':
                    print >>sys.stderr,"*error* missing } in ",position
                    sys.exit(1)
                else:
                    generator=randomRange
            if position[0]=='[':
                if position[-1]!=']':
                    print >>sys.stderr,"*error* missing ] in ",position
                    sys.exit(1)
                else:
                    generator=range
            values=position[1:-1].split(':')
            if len(values)!=3:
                print >>sys.stderr,"*error* 3 values expected in ",position  
                sys.exit(1)      
            if values[0].strip()=="":
                b=POSITION_SHIFT
            else:
                try:
                    b=int(values[0])
                except ValueError, e:
                    print >>sys.stderr,"*error* ",e
                    print >>sys.stderr,"*error* integer expected as first value in ",position
                    sys.exit(1)
            if values[1].strip()=="":
                e=POSITION_SHIFT+len(sequence)-length
            else:
                try:
                    e=int(values[1])
                except ValueError, e:
                    print >>sys.stderr,"*error* ",e
                    print >>sys.stderr,"*error* integer expected as second value in ",position 
                    sys.exit(1)   
            try:
                s=int(values[2])
            except ValueError, e:
                print >>sys.stderr,"*error* ",e
                print >>sys.stderr,"*error* integer expected as third value in ",position  
                sys.exit(1)
            positions+=[(p,reverse,length) for p in generator(b,e,s)]
        else:  
            try:
                v=int(position)
            except ValueError, e:
                print >>sys.stderr,"*error* ",e
                print >>sys.stderr,"*error* integer expected in ",position
                sys.exit(2)
            positions.append((v,reverse,length))
    return positions
        
def getStrFromFormat(format,method,options,absNumber,number,start,end,length,watson,name,shortName,numeroSequence):
    result=format
    if watson:
        sens="W"
    else:
        sens="C"
    if name==None:
        name=""
    for s,v in [("%m",method),("%o",options),("%n",str(number).zfill(3)),("%N",str(absNumber).zfill(3)),("%s",str(start)),("%e",str(end)),("%l",str(length)),("%x",sens),("%f",name),("%t","\t"),("%F",shortName),("%i",str(numeroSequence).zfill(3))]:
        result=result.replace(s,v)
    return result


def openFile(fileName):
    dirName=os.path.dirname(fileName)
    if dirName!="" and os.access(dirName,os.W_OK)==False:
        try:
            os.makedirs(dirName)
        except:
            print >>sys.stderr,"*error* can't create directory ",dirName
    try:
        f=file(fileName,"a")
    except:
            print >>sys.stderr,"*error* can't create file ",fileName
    return f            
    

def usage():
    print """\
Usage:
%(prog)s [options] fasta positions
for details hit << %(prog)s -h >> 
"""%{"prog":sys.argv[0]}
    sys.exit(1)


def help():
    global FILENAME_FORMAT, DESCRIPTION_FORMAT;
    print """\
Usage:
%(prog)s [options] fasta [positions]

options:
-h,--help            : this help
--mfold              : compute foldings with mfold
--mfold-opt str      : options passed to mfold
--rnashapes          : compute foldings with RNAshapes
--rnashapes-opt str  : options passed to RNAshapes
--rnasubopt          : compute foldings with RNAsubopt
--rnasubopt-opt str  : options passed to Rnasubopt
-f,--filename str    : format that should be used to name each fold filename.
                       You can use the %% symbol to indicate the following values
                       %%m : name of the method (mfold/shape/subopt)
                       %%o : options used with the method
                       %%n : the relative folding number on 3 digits
                       %%N : the absolute folding number on 3 digits
                       %%s : the start position of the subsequence in the sequence
                       %%e : the end position of the subsequence in the sequence
                       %%l : the length of the subsequence folded
                       %%x : the orientation of the subsequence (W for watson and C for crick)
                       %%f : the name of the input sequence (see --sequence-name).
                       %%F : the first word after the > in the fasta first line
                       %%t : replaced by a tabulation \\t
                       You can also use %(separator)s in str to create directories
                       Default is << %(filename_format)s >>
-d,--description str : texte used for the description (name) of each fold (after the >).
                       The format is the same as above, the default value is
                       << %(description_format)s >>
--sequence-name      : set the name of the input sequence (default is the name given in the fasta file)
--crick              : initial sequence is the crick. Default is watson.
-l n                 : the length of each subsequence. Default is the sequence length
-s                   : first argument is not a file name but the sequence itself
--start n            : indice of the first nucleotide (default is 1)

fasta: the name of a fasta file containing the sequence or the sequence is option -s positioned

positions: a list of positions defined as value separated by comma. For each value v, the sub
   sequence [v...v+n] is folded. You can also define range as follow: [b:e:s], this will
   consider the values from b to e every s. An empty value for b means the beginning of the
   sequence, an empty value for e means the end of the sequence minus n (see -l). Also, you
   can peek random positions into a range using {b:e:r} where b and e delimit the range
   for positions and r the number of random position to generate. Finally, you can prefix
   each positions by 'R' to indicate that the subsequence is the reverse complement.
   If positions is not specified then only position 0 is considered.

   

examples:

fold one sequence using mfold RNAshapes and RNAsubopt:
   %(prog)s --mfold --rnashapes --rnasubopt -s AACCGCAUUUUGAAACAGGAAAACAGGAUUUGA 
fold subsequences of size 10 every 2 nucleotides using mfold
   %(prog)s --mfold -s -l 10 AACCGCAUUUUGAAACAGGAAAACAGGAUUUGA [::2]
the same but put all folds into one file named mfold.fasta in current directory:
   %(prog)s --mfold -f "%%m.fasta" -s -l 10 AACCGCAUUUUGAAACAGGAAAACAGGAUUUGA [::2]
fold 5 random subsequence of length 8 using RNAshapes:
   %(prog)s --rnashapes -l 8 -s AACCGCAUUUUGAAACAGGAAAACAGGAUUUGA "{::5}"
"""%{"prog":sys.argv[0],"separator":os.path.sep,"filename_format":FILENAME_FORMAT,"description_format":DESCRIPTION_FORMAT}
    sys.exit(1)

##
## Options:
##
MFOLD=False
MFOLD_OPT=""
RNASHAPES=False
RNASHAPES_OPT=""
RNASUBOPT=False
RNASUBOPT_OPT=""
RNAFOLD=False
RNAFOLD_OPT=""
SUBSEQUENCE_LENGTH=None
FILENAME_FORMAT="folds/%s/%m_%i.dp"
SEQUENCE_FASTA=True
DESCRIPTION_FORMAT="%m %o: %s => %e"
SEQUENCE_WATSON=True
SEQUENCE_NAME=None
SEQUENCE_SHORT_NAME=""
POSITION_SHIFT=1

try:
    options, arguments = getopt.getopt(sys.argv[1:], 'f:l:shd:',['mfold','mfold-opt=','rnashapes','rnashapes-opt=','rnafold','rnafold-opt=','rnasubopt','rnasubopt-opt=','filename=','description=','help','crick','sequence-name=','start='])
except getopt.GetoptError,e:
    print >>sys.stderr,"*error*",e
    usage()


for option,value in options:
    if option in ('-h','--help'):
        help()
    elif option in ('--start',):
        try:
            POSITION_SHIFT=int(value)        
        except:
            print >>sys.stderr, "*error* option --start: integer expected"
            usage()
    elif option in ('--crick',):
        SEQUENCE_WATSON=False
    elif option in ('--sequence-name',):
        SEQUENCE_NAME=value
    elif option in ('--rnafold',):
        RNAFOLD=True
    elif option in ('--rnafold-opt',):
        RNAFOLD_OPT=value
    elif option in ('--mfold',):
        MFOLD=True
    elif option in ('--mfold-opt',):
        MFOLD_OPT=value
    elif option in ('--rnashapes',):
        RNASHAPES=True
    elif option in ('--rnashapes-opt',):
        RNASHAPES_OPT=value
    elif option in ('--rnasubopt',):
        RNASUBOPT=True
    elif option in ('--rnasubopt-opt',):
        RNASUBOPT_OPT=value
    elif option in ('-f','--filename'):
        FILENAME_FORMAT=value
    elif option in ('-d','--description'):
        DESCRIPTION_FORMAT=value
    elif option in ('-l',):
        try:
            SUBSEQUENCE_LENGTH=int(value)
        except:
            print >>sys.stderr, "*error* option -l: integer expected"
            usage()
    elif option in ('-s',):
        SEQUENCE_FASTA=False

if len(arguments)<1:
    print >>sys.stderr,"*error* at least one argument expected"
    usage()

if SEQUENCE_FASTA:
    try:
        sequence_file=file(arguments[0],"r")
    except IOError, (errno, strerror):
        print >>sys.stderr,"*error*",arguments[0],":",strerror
        sys.exit(1)
    sequence=""
    for line in sequence_file:
        if line[0]==">":
            if SEQUENCE_NAME==None:
                SEQUENCE_NAME=line[1:].strip()
                SEQUENCE_SHORT_NAME=line[1:].split()[0]
            if len(sequence)>0:
                break
        else:
            sequence+=line.strip()
else:
    sequence=arguments[0]

if len(sequence)==0:
    print >>sys.stderr,"*error* empty sequence"
    sys.exit(1)        

if SUBSEQUENCE_LENGTH==None:
    SUBSEQUENCE_LENGTH=len(sequence)

if len(arguments)==1:
    positions=[(POSITION_SHIFT,False,SUBSEQUENCE_LENGTH)]
else:
    positions=parsePositions(arguments[1])

print len(positions)

progs=[]
if MFOLD:
    progs.append(("mfold",MFold(),MFOLD_OPT))
if RNASUBOPT:
    progs.append(("subopt",RNAsubopt(),RNASUBOPT_OPT))
if RNASHAPES:
    progs.append(("shape",RNAshapes(),RNASHAPES_OPT))
if RNAFOLD:
    progs.append(("rnafold",RNAfold(),RNAFOLD_OPT))

N=0
for position,reverse,length in positions:
    if position-POSITION_SHIFT<0:        
        print >>sys.stderr,"*error*: position ",position," is before the beginning of the sequence (--start ",POSITION_SHIFT,")";
        sys.exit(1)
for position,reverse,length in positions:
    print position-POSITION_SHIFT,reverse,length
    subsequence=sequence[position-POSITION_SHIFT:position-POSITION_SHIFT+length]
    sens=SEQUENCE_WATSON
    if reverse:
        sens=not sens
        subsequence = reverseComplement(subsequence)
    numSequence=0
    for name,obj,options in progs:
        folds=obj.fold(subsequence,options)
        n=0
        for fold in folds:
            f=openFile(getStrFromFormat(FILENAME_FORMAT,method=name,options=options,absNumber=N,number=n,start=position,end=position+length,length=length,watson=sens,name=SEQUENCE_NAME,shortName=SEQUENCE_SHORT_NAME,numeroSequence=numSequence))
            d=getStrFromFormat(DESCRIPTION_FORMAT,method=name,options=options,absNumber=N,number=n,start=position,end=position+length,length=length,watson=sens,name=SEQUENCE_NAME,shortName=SEQUENCE_SHORT_NAME,numeroSequence=numSequence)
            print >>f,'>',d
            f.write(fold[1])
            f.write(fold[2])
            f.close()
            n+=1
            N+=1
            numSequence+=1
